package com.zm.order.tool.server.listener.reverse;

import com.alibaba.fastjson.JSON;
import com.google.common.collect.Lists;
import com.zm.order.tool.server.constants.UpgradeSellerLists;
import com.zm.order.tool.server.dao.OrderCommentDao;
import com.zm.order.tool.server.manager.NewHintManager;
import com.zm.order.tool.server.model.KafkaConsumerMessage;
import com.zm.order.tool.server.model.Order;
import com.zm.order.tool.server.model.OrderComment;
import com.zm.order.tool.server.newdatasource.NewDataSourceOrderCommentDao;
import com.zm.order.tool.server.newdatasource.NewDataSourceOrderDao;
import com.zm.order.tool.server.stream.convert.PayDetailStreamConverter;
import org.apache.kafka.clients.consumer.ConsumerRecord;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.factory.annotation.Value;
import org.springframework.kafka.annotation.KafkaListener;
import org.springframework.kafka.support.Acknowledgment;
import org.springframework.stereotype.Component;
import org.springframework.util.CollectionUtils;
import org.springframework.util.StringUtils;

import java.util.List;
import java.util.Objects;

/**
 * binlog监听
 *
 * @author nianchang
 * @date 2021/12/21 2:34 下午
 */
@Component
@SuppressWarnings("all")
public class ResConvertCommentSyncListener {

    private static final Logger logger = LoggerFactory.getLogger(ResConvertCommentSyncListener.class);

    @Autowired
    private NewHintManager hintManager;

    @Autowired
    private NewDataSourceOrderCommentDao newCommentDao;

    @Autowired
    private OrderCommentDao commentDao;
    
    @Autowired
    private PayDetailStreamConverter converter;
    
    @Autowired
    private NewDataSourceOrderDao orderDao;

    @Value("${new.sharding.db.size}")
    private int dbSize;

    @Value("${new.sharding.tb.size}")
    private int tbSize;

    @KafkaListener(topics = "${kafka.bin.log.sync.order.comment.topic}")
    public void consumer(List<ConsumerRecord<String, String>> recordList, Acknowledgment ack) {
        try {
            logger.info("[bin_log_sync_comment_consumer]before！");
            if (CollectionUtils.isEmpty(recordList)) {
                return;
            }
            for (ConsumerRecord<String, String> record : recordList) {
                OrderComment model = parse(record);
                if (model != null) {
                    logger.info("[bin_log_sync_res_comment_consumer_0]model:{}", model);
                    if (Objects.equals(1, model.getMasterDataSource())) {
                        return;
                    }
                    if (!UpgradeSellerLists.LIST.contains(model.getSellerId())) {
                        logger.info("Filter res un upgrade seller comment. orderNo:{}", model.getOrderNo());
                        return;
                    }
                    logger.info("[bin_log_sync_res_comment_consumer_33321] orderNo:{}", model.getOrderNo());
                    final Long id = model.getId();
                    final Long sellerId = model.getSellerId();
                    OrderComment comment = newCommentDao.selectById(sellerId, id);
                    OrderComment replace = comment == null ? model : commentDao.selectById(sellerId, id);

                    if (replace != null) {
                        Order order = orderDao.selectByOrderNo(replace.getOrderNo(), replace.getUserId());
                        if (order != null) {
                            replace.setBizType(order.getBizType());
                            replace.setOrderType(order.getOrderType());
                            replace.setOrderSubType(order.getOrderSubType());
                            replace.setPerformanceType(order.getPerformanceType());
                        }
                        newCommentDao.replaceList(Lists.newArrayList(replace));
                    }
                }
            }
        } catch (Exception e) {
            logger.error("ConvertCommentSyncListener[res_comment_consumer_fail]failed！msg:{}, cause by:{}", recordList, e);
        } finally {
            ack.acknowledge();
        }
    }

    private OrderComment parse(ConsumerRecord<String, String> record) {
        String dataSource = record.value();
        if (StringUtils.isEmpty(dataSource)) {
            return null;
        }
        KafkaConsumerMessage message = JSON.parseObject(dataSource, KafkaConsumerMessage.class);
        return JSON.parseObject(message.getData(), OrderComment.class);
    }
}
